/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   GinkoState.h
 * Author: Martin Kjellqvist <martin.kjellqvist@miun.se>
 *
 * Created on February 25, 2018, 5:20 PM
 */

#ifndef GINKOSTATE_H
#define GINKOSTATE_H

#include <map>
#include <string>
#include <vector>

using board_state_t = std::string;

enum TileType{
    NONE, 
    SQUARE,
    VERTICAL,
    HORIZONTAL,
    BIG, 
    EMPTY,
    LAST
};

struct Move {
    std::pair<char, char> from_row_col;
    std::pair<char, char> to_row_col;
};

using solution_t = std::map<board_state_t, Move>;

std::string state_for_tile(TileType tiletype);

std::vector<TileType> tiles_for_state(board_state_t state);

#endif /* GINKOSTATE_H */

